#include<iostream>
#include<cstring>
#include<stdlib.h>
#include"ezwin.h"
#include<rect.h>
#include<cassert>
#include "final.h"
#include "read.cpp"
#include"common.cpp"
using namespace std;

	

//DECLARATION FOR DRAWING THE GRAPH
int graph1()
{
SimpleWindow dk("Graph analysing the geographical zones of the selected students",25.0,15.0,Position(1.0,1.0));	

//INITIALISING THE STRUCTURES TO BE USED FOR THE GRAPHS AND DATA HANDLING	
struct bgraph b[100];
struct dgraph d[100];
struct kgraph k[100];
struct rgraph r[100];
struct mgraph m[100];
int i,y1,y2,y3,y4,y5;
c(b,k,d,r,m,y1,y2,y3,y4,y5);

//GRAPH b/w THE NO OF STUDENTS AND THE CORRESPONDING ZONE

//USER GIVES INPUT REGARDING THE RANK UPTO WHICH HE WANTS TO ANALYSE THE RANKS

	int uplim;
	cout<<"ENTER THE UPPER LIMIT OF THE RANK YOU WANT TO ANALYSE BUT LESS THAN EQUAL TO TOTAL NO. OF STUDENTS  ("<<readstudentslist(s,ar)<<"):"<<endl;
	cin>>uplim;
	if(uplim>readstudentslist(s,ar)){cout<<"Sorry ,these many ranks have not been allotted"<<endl;return 1;}
	float S=0.0,N=0.0,E=0.0,W=0.0;
	
	
//READING DATA FROM THE FILE CONTAINING THE DATA OF THE STUDENTS OF BOMBAY
    FILE *fp1,*fp2,*fp3,*fp4,*fp5;
	fp1=fopen("B.txt","r");
	if (fp1==NULL)
		{}	
	else{		
		 for(i=0;i<y1;i++)		// APPLYING LOOP FOR FINDING NO. OF STUDENTS FROM DIFFERENT ZONES AND STORING THEM IN N,S,E,W ; WHOSE RANK LESS THAN 										EQUAL TO GIVEN RANK FROM IIT BOMBAY...
			{
			if(atoi(b[i].rank)<uplim+1)				
				{
					if(b[i].reg[0]=='N')
							{N++;}
					else if((b[i].reg[0])=='S')
							{S++;}
					else if((b[i].reg[0])=='E')
							{E++;}
					else if((b[i].reg[0])=='W')
							{W++;}
		        }
		    }
	}
	
	
	
//READING DATA FROM THE FILE CONTAINING THE DATA OF THE STUDENTS OF DELHI
	fp2=fopen("D.txt","r");
	if (fp2==NULL)
		{}	
	else{	
	    for(i=0;i<y2;i++)		// APPLYING LOOP FOR FINDING NO. OF STUDENTS FROM DIFFERENT ZONES AND  INCREASING  VALUES OF N,S,E,W ...
		  {
		  if(atoi(d[i].rank)<uplim+1)
			{
				if(d[i].reg[0]=='N')
						{N++;}
				else if((d[i].reg[0])==('S'))
						{S++;}
				else if((d[i].reg[0])=='E')
						{E++;}
			    else if((d[i].reg[0])==('W'))
						{W++;}
			}
		 }
	}
	
	
	
//READING DATA FROM THE FILE CONTAINING THE DATA OF THE STUDENTS OF KANPUR
	fp3=fopen("K.txt","r");
	if (fp3==NULL)
		{}	
	else{	
		for(i=0;i<y3;i++)	// APPLYING LOOP FOR FINDING NO. OF STUDENTS FROM DIFFERENT ZONES AND  INCREASING  VALUES OF N,S,E,W ...
		{
			if(atoi(k[i].rank)<uplim+1)
			{
				if(k[i].reg[0]=='N')
					{N++;}
			 	else if((k[i].reg[0])==('S'))
					{S++;}
			 	else if((k[i].reg[0])=='E')
					{E++;}
	            else if((k[i].reg[0])==('W'))
					{W++;}
			}
		}	
	}
	
	
//READING DATA FROM THE FILE CONTAINING THE DATA OF THE STUDENTS OF ROORKEE
	fp4=fopen("R.txt","r");
	if (fp4==NULL)
		{}	
	else{	
		for(i=0;i<y4;i++)	// APPLYING LOOP FOR FINDING NO. OF STUDENTS FROM DIFFERENT ZONES AND  INCREASING  VALUES OF N,S,E,W ...
			{
			if(atoi(r[i].rank)<uplim+1)
				{
			
				if(r[i].reg[0]=='N')
						{N++;}
				else if((r[i].reg[0])==('S'))
						{S++;}
				else if((r[i].reg[0])=='E')
						{E++;}
			    else if((r[i].reg[0])==('W'))
						{W++;}
				}
	       }
	  } 
	
//READING DATA FROM THE FILE CONTAINING THE DATA OF THE STUDENTS OF MADRAS
	fp5=fopen("M.txt","r");
	if (fp5==NULL)
		{}	
	else{	
   		for(i=0;i<y5;i++)	// APPLYING LOOP FOR FINDING NO. OF STUDENTS FROM DIFFERENT ZONES AND  INCREASING  VALUES OF N,S,E,W...
			{
			 if(atoi(m[i].rank)<uplim+1)
				{
				if(m[i].reg[0]=='N')
						{N++;}
				else if((m[i].reg[0])==('S'))
						{S++;}
				else if((m[i].reg[0])=='E')
						{E++;}
			    else if((m[i].reg[0])==('W'))
						{W++;}
			    }						
			}		
       }

//CREATING THE REFERENCE LINES IN THE GRAPH
	float x,q=14.0,r1=2.0;
	dk.Open();
	assert(dk.GetStatus()==WindowOpen);
	for(x=1.0;x<=25.0;x=x+1.0)
		{dk.RenderLine(Position(x,0.0),Position(x,q),Black,0.0);}
	for(x=1.0;x<=q;x=x+1.0)
		 {dk.RenderLine(Position(1.0,x),Position(25.0,x),Black,0.0);}
		
			
//FLEXIBLE SCALING OF THE GRAPH
//HERE 'p' HAS BEEN USED AS A VARIABLE WHICH ADJUSTS THE SCALE OF THE GRAPHS ACCORDING TO THE DATA RECEIVED
    float p;
	for(p=0;;)
	 {
	 p++;
	 if((N/p<q) && (W/p<q) && (E/p<q) && (S/p<q))
	 {break;}
	 }


//CREATING THE RECTANGLE BOXES THAT WOULD REPRESENT THE GRAPH
	dk.RenderRectangle(Position(r1,q-N/p),Position(r1+1,q),Red,false);
	dk.RenderRectangle(Position(r1+2,q-S/p),Position(r1+3,q),Red,false);
	dk.RenderRectangle(Position(r1+4,q-(E/p)),Position(r1+5,q),Red,false);
	dk.RenderRectangle(Position(r1+6,q-W/p),Position(r1+7,q),Red,false);

		
	char header[15],str[15];
	int n;
	
		
//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE VERTICAL AXIS		
	for(n=0;n<14;n++)
	{
	 int j1=n*p;
	 sprintf(str,"%d",j1);
	 sscanf(str,"%s",header);
			{
			Position UpperLeft = Position(0.0,q-n-0.5);
			Position LowerRight = Position(1.0,q-n+0.5);
			dk.RenderText(UpperLeft, LowerRight,header, Red);
			}
	}


//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE HORIZONTAL AXIS
	{		Position UpperLeft = Position(r1,q);
			Position LowerRight = Position(r1+1,q+1);
			dk.RenderText(UpperLeft, LowerRight,"NORTH", Red);
	}
	
	
	{	    Position UpperLeft = Position(r1+2,q);
			Position LowerRight = Position(r1+3,q+1);
			dk.RenderText(UpperLeft, LowerRight,"SOUTH", Red);
	}
	
	
	{		Position UpperLeft = Position(r1+4,q);
			Position LowerRight = Position(r1+5,q+1);
			dk.RenderText(UpperLeft, LowerRight,"EAST", Red);
	}
	
    {		Position UpperLeft = Position(r1+6,q);
			Position LowerRight = Position(r1+7,q+1);
			dk.RenderText(UpperLeft, LowerRight,"WEST", Red);
			dk.RenderText(UpperLeft, LowerRight,"WEST", Red);
	}
sleep(10);
return 0;
}
