#include<iostream>
#include<cstring>
#include<stdlib.h>
#include"ezwin.h"
#include<rect.h>
#include<cassert>
using namespace std;




int graph2()
{
	SimpleWindow dk("Graph analysing the gender ratio of students admitted to iit",25.0,15.0,Position(1.0,1.0));

//INITIALIZING THE STRUCTURES TO BE USED

	struct bgraph b[100];
	struct dgraph d[100];
	struct kgraph k[100];
	struct rgraph r[100];
	struct mgraph m[100];
	int i,y1,y2,y3,y4,y5;
	c(b,k,d,r,m,y1,y2,y3,y4,y5);

//DRAWING THE GRAPH FOR NO OF MALES AND FEMALES 
//USER WILL INPUT THE MAXIMUM VALUE OF RANK UPTO WHICH HE WISHES TO ANALYSE THE RANKS
//DEFINING THE FILES FROM WHICH DATA INPUT IS TO BE DONE
	
	int uplim2;int m1=0,f1=0;
	cout<<"ENTER THE UPPER LIMIT OF THE RANK YOU WANT TO ANALYSE BUT LESS THAN EQUAL TO TOTAL NO. OF STUDENTS  ("<<readstudentslist(s,ar)<<"):"<<endl;
	cin>>uplim2;	
	if(uplim2>readstudentslist(s,ar)){cout<<"Sorry ,these many ranks have not been allotted"<<endl;return 1;}
	
	
//m1=NO. OF MALES
//f1=NO. OF FEMALES
//SEARCHING FOR THE NO OF MALES AND FEMALES IN IIT BOMBAY	

	FILE *fp1,*fp2,*fp3,*fp4,*fp5;
	fp1=fopen("B.txt","r");
	if (fp1==NULL)
		{}	
	else    {
		for(i=0;i<y1;i++)		// APPLYING LOOP FOR FINDING NO. OF BOYS AND GIRLS AND STORING THEM IN  M AND F; WHOSE RANK LESS THAN 										EQUAL TO GIVEN RANK ...
		{
			if(atoi(b[i].rank)<(uplim2+1))
			{
				if((b[i].gen[0])==('M'))
					{m1++;}
			 	else if((b[i].gen[0])==('F'))
					{f1++;};
			}	
		}		
		}		
	
//SEARCHING FOR THE NO OF MALES AND FEMALES IN IIT DELHI
	
	fp2=fopen("D.txt","r");
	if (fp2==NULL)
		{}	
	else    {
		for(i=0;i<y2;i++)		// APPLYING LOOP FOR FINDING NO. OF BOYS AND GIRLS AND INCREASING M AND F ACCORDING TO THAT.....
		{
			if(atoi(d[i].rank)<(uplim2+1))
			{
				if((d[i].gen[0])==('M'))
					{m1++;}
					else if((d[i].gen[0])==('F'))
					{f1++;};
			}
		}	
		}

//SEARCHING FOR THE NO OF MALES AND FEMALES IN IIT KANPUR
	
	fp3=fopen("K.txt","r");
	if (fp3==NULL)
		{}	
	else{
		for(i=0;i<y3;i++)		// APPLYING LOOP FOR FINDING NO. OF BOYS AND GIRLS AND INCREASING M AND F ACCORDING TO THAT.....
		{	
			 if(atoi(k[i].rank)<(uplim2+1))
			 {
			 	if((k[i].gen[0])==('M'))
				{m1++;}
				else if((k[i].gen[0])==('F'))
				{f1++;};
			 }
		}	
		}	

	
	
//SEARCHING FOR THE NO OF MALES AND FEMALES IN IIT ROORKEE(if present)

	fp4=fopen("R.txt","r");
	if (fp4==NULL)
		{}	
	else{	
		for(i=0;i<y4;i++)		// APPLYING LOOP FOR FINDING NO. OF BOYS AND GIRLS AND INCREASING M AND F ACCORDING TO THAT.....
		{	
			if(atoi(r[i].rank)<(uplim2+1))
			{
				if((r[i].gen[0])==('M'))
				{m1++;}
				else if((r[i].gen[0])==('F'))
				{f1++;};
			}
		}	
		}
	
//SEARCHING FOR THE NO OF MALES AND FEMALES IN IIT MADRAS(if present)

	fp5=fopen("M.txt","r");
	if (fp5==NULL)
		{}	
	else{		
    		for(i=0;i<y5;i++)		// APPLYING LOOP FOR FINDING NO. OF BOYS AND GIRLS AND INCREASING M AND F ACCORDING TO THAT.....
		{	
			if(atoi(m[i].rank)<(uplim2+1))
			{
				if((m[i].gen[0])==('M'))
				{m1++;}
			 	else if((m[i].gen[0])==('F'))
				{f1++;};
			}
		}
		}		
		
//RECEIVED THE NO OF MALES AND FEMALES IN ALL THE COLLEGES
//NOW,DRAWING THE GRAPHS
//FOLLOWING CODE DRAWS THE LINES TO BE USED AS REFERENCE LINES IN THE GRAPHS		
		
			
	
	float x,q=14.0,r1=2.0;
	dk.Open();
	assert(dk.GetStatus()==WindowOpen);
	
	for(x=1.0;x<=25.0;x=x+1.0)
		{dk.RenderLine(Position(x,0.0),Position(x,q),Black,0.0);}
	for(x=1.0;x<=q;x=x+1.0)
		{dk.RenderLine(Position(1.0,x),Position(25.0,x),Black,0.0);
		}	

//FOLLOWING CODE ADJUSTS THE SCALE OF THE GRAPH ACCORDING TO THE DATA RECEIVED 
//USING 'p' AS A VARIABLE TO CONTROL THE SCALING OF THE GRAPHS

	float p;
	for(p=0;;)
	{
		p++;
		if((m1/p<q) && (f1/p<q))
	{	break;
	}
	}
  
	char header[15],str[15];
	int n;
	
//DISPLAYING THE TEXT ON THE VERTICAL AXIS

	for(n=0;n<14;n++)
	{
		int j1=n*p;
		sprintf(str,"%d",j1);
		sscanf(str,"%s",header);

		{Position UpperLeft = Position(0.0,q-n-0.5);
		 Position LowerRight = Position(1.0,q-n+0.5);
		 dk.RenderText(UpperLeft, LowerRight,header, Red);
		}


	}


	{dk.RenderRectangle(Position(r1,q-m1/p),Position(r1+1,q),Green,false);}
	{dk.RenderRectangle(Position(r1+2,q-f1/p),Position(r1+3,q),Green,false);}
		
//DISPLAYING THE TEXT ON THE HORIZONTAL AXIS

	{Position UpperLeft = Position(r1,q);
	 Position LowerRight = Position(r1+1,q+1);
	 dk.RenderText(UpperLeft,LowerRight,"male",Green);}
	
	{Position UpperLeft = Position(r1+2,q);
	 Position LowerRight = Position(r1+3,q+1);
	 dk.RenderText(UpperLeft,LowerRight,"female", Green);
	 dk.RenderText(UpperLeft,LowerRight,"female", Green);}
	
//SETTING THE TIMER FOR 15 SECS	
//THE GRAPH AUTOMATICALLY TERMINATES AFTER 15 SECS
	
	
	sleep(7);
	
	return 0;	
	
}
