#include<iostream>
#include<cstring>
#include<stdlib.h>
#include<stdio.h>
#include"ezwin.h"
#include<rect.h>
#include<cassert>
using namespace std;

	

//FUNCTION FOR CALCULATING THE NO OF STUDENTS WHO HAVE TAKEN ADMISSION OR REJECTED ADMISSION TO A PARTICULAR IIT

int graph3()
{

SimpleWindow dk("Graph analysing the students admitted in different IIT's",25.0,15.0,Position(1.0,1.0));
	
//INITIALISING THE GRAPHS REQD FOR DATA HANDLING

struct bgraph b[100];
struct dgraph d[100];
struct kgraph k[100];
struct rgraph r[100];
struct mgraph m[100];
int i,y1,y2,y3,y4,y5;
c(b,k,d,r,m,y1,y2,y3,y4,y5);



//USER GIVES INPUT REGARDING THE RANK UPTO WHICH HE WANTS TO ANALYSE THE RANKS			
	int b1=0,d1=0,k1=0,r1=0,m1=0;
	int uplim;
	cout<<"ENTER THE UPPER LIMIT OF THE RANK YOU WANT TO ANALYSE BUT LESS THAN EQUAL TO TOTAL NO. OF STUDENTS  ("<<readstudentslist(s,ar)<<"):"<<endl;
	cin>>uplim;
	if(uplim>readstudentslist(s,ar)){cout<<"Sorry ,these many ranks have not been allotted"<<endl;return 1;}

	FILE *fp1,*fp2,*fp3,*fp4,*fp5;

//CALCULATION OF THE STUDENTS IN IIT BOMBAY WITHIN THE DESIRED RANGE OF RANK

	fp1=fopen("B.txt","r");
	if (fp1==NULL)
		{}	
	else{		
		for(i=0;i<y1;i++)		
		{
		if(atoi(b[i].rank)<uplim+1){b1++;}		////USING atoi() TO CONVERT STRING TO INTEGER...
		}
	    }
		
		
//CALCULATION OF THE STUDENTS IN IIT DELHI WITHIN THE DESIRED RANGE OF RANK	

	fp2=fopen("D.txt","r");
	if (fp2==NULL)
		{}	
	else{		
						
		for(i=0;i<y2;i++)
		{
		if(atoi(d[i].rank)<uplim+1){d1++;}
		}		
	    }

//CALCULATION OF THE STUDENTS IN IIT KANPUR WITHIN THE DESIRED RANGE OF RANK		

	fp3=fopen("K.txt","r");
	if (fp3==NULL)
		{}	
	else{	

		for(i=0;i<y3;i++)
		{
		if(atoi(k[i].rank)<uplim+1){k1++;}
		}
	    }
		
//CALCULATION OF THE STUDENTS IN IIT ROORKEE WITHIN THE DESIRED RANGE OF RANK		

	fp4=fopen("R.txt","r");
	if (fp4==NULL)
		{}	
	else{	

		for(i=0;i<y4;i++)
		{
		if(atoi(r[i].rank)<uplim+1){r1++;}
		}
	    }	
		
//CALCULATION OF THE STUDENTS IN IIT MADRAS WITHIN THE DESIRED RANGE OF RANK

	fp5=fopen("M.txt","r");
	if (fp5==NULL)
		{}	
	else{	

		for(i=0;i<y5;i++)
		{
		if(atoi(m[i].rank)<uplim+1){m1++;}
		}

	    }

//'b1','k1','d1','r1','m1' REFER TO THE NO OF STUDENTS WHO HAVE TAKEN ADMISSION IN IIT BOMBAY,IIT KANPUR,IIT DELHI,IIT ROORKEE AND IIT MADRAS RESPECTIVELY
	int z=uplim-b1-k1-d1-r1-m1;		//'z' REFER TO THE STUDENTS WHO HAVE NOT TAKEN ADMISSION IN ANY IIT IN THE RANGE OF GIVEN RANK..
	

//CREATING THE REFERENCE LINES IN THE GRAPHS
	
	float x,q=14.0,r2=2.0,r3=2.0;
	dk.Open();
	assert(dk.GetStatus()==WindowOpen);
	for(x=1.0;x<=25.0;x=x+1.0)
		{dk.RenderLine(Position(x,0.0),Position(x,q),Black,0.0);}
	for(x=1.0;x<=q;x=x+1.0)
		 {dk.RenderLine(Position(1.0,x),Position(25.0,x),Black,0.0);
		}	


//FLEXIBLE SCALING OF THE GRAPH
//HERE 'p' HAS BEEN USED AS A VARIABLE WHICH ADJUSTS THE SCALE OF THE GRAPHS ACCORDING TO THE DATA RECEIVED


	float p;
	for(p=0;;)
		{
		 p++;
		 if((b1/p<q) && (d1/p<q) && (k1/p<q))
		 {break;}
		 }
		
//CREATING THE RECTANGLES WHICH WILL FORM THE GRAPH PIECE BY PIECE

	char header[15],str[15];
	float n;
	
	if (fp1==NULL)
	{}	
	else{dk.RenderRectangle(Position(r2,q-b1/p),Position(r2+1,q),Red,false);r2=r2+2;}
	
	
	
	if (fp2==NULL)
	{}	
	else{dk.RenderRectangle(Position(r2,q-d1/p),Position(r2+1,q),Red,false);r2=r2+2;}
		
		
	
	if (fp3==NULL)
	{}	
	else{dk.RenderRectangle(Position(r2,q-k1/p),Position(r2+1,q),Red,false);r2=r2+2;}
	
	
	
	if (fp4==NULL)
	{}	
	else{dk.RenderRectangle(Position(r2,q-r1/p),Position(r2+1,q),Red,false);r2=r2+2;}
	
		
	
	if (fp5==NULL)
	{}	
	else{dk.RenderRectangle(Position(r2,q-m1/p),Position(r2+1,q),Red,false);r2=r2+2;}	

	
	dk.RenderRectangle(Position(r2,q-z/p),Position(r2+1,q),Red,false);
		
//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE HORIZONTAL AXIS
	
	if (fp1==NULL)
	{}	
	else{Position UpperLeft = Position(r3,q);
	     Position LowerRight = Position(r3+1,q+1);
	     dk.RenderText(UpperLeft, LowerRight,"IITB", Red);
	     r3=r3+2;
	     }

	if (fp2==NULL)
	{}	
	else{Position UpperLeft = Position(r3,q);
	     Position LowerRight = Position(r3+1,q+1);
	     dk.RenderText(UpperLeft, LowerRight,"IITD", Red);
	     r3=r3+2;
	     }

	if (fp3==NULL)
	{}	
	else{Position UpperLeft = Position(r3,q);
	     Position LowerRight = Position(r3+1,q+1);
	     dk.RenderText(UpperLeft, LowerRight,"IITK", Red);
	     r3=r3+2;
	     }
		
		
	if (fp4==NULL)
	{}	
	else{Position UpperLeft = Position(r3,q);
	     Position LowerRight = Position(r3+1,q+1);
	     dk.RenderText(UpperLeft, LowerRight,"IITR", Red);
	     r3=r3+2;
	     }
		
		
	if (fp5==NULL)
	{}	
	else{Position UpperLeft = Position(r3,q);
	     Position LowerRight = Position(r3+1,q+1);
	     dk.RenderText(UpperLeft, LowerRight,"IITM", Red);
	     r3=r3+2;
	    }			
		
		
	if(z!=0)
	{Position UpperLeft = Position(r3,q);
	Position LowerRight = Position(r3+1,q+1);
	dk.RenderText(UpperLeft, LowerRight,"Other colleges", Red);
	r3=r3+2;
	}
		
//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE VERTICAL AXIS
		
	for(n=0;n<14;n++)
	{
	 int j1=n*p;
	 sprintf(str,"%d",j1);
	 sscanf(str,"%s",header);
			Position UpperLeft = Position(0.0,q-n-0.5);
			Position LowerRight = Position(1.0,q-n+0.5);
			dk.RenderText(UpperLeft, LowerRight,header, Red);
	}
		Position UpperLeft = Position(0.0,q-13-0.5);
		Position LowerRight = Position(1.0,q-13+0.5);	
		dk.RenderText(UpperLeft, LowerRight,header, Red);

	sleep(10);
return 0;
}
	
