#include<iostream>
#include<cstring>
#include<stdlib.h>
#include<stdio.h>
#include"ezwin.h"
#include<rect.h>
#include<cassert>


using namespace std;

//FUNCTION FOR COMPARING THE BRANCHES OF STUDENTS AND CALCULATING THE NO OF SEATS FILLED FOR EVERY BRANCH

int cs=0.0,ai=0.0,ee=0.0,me=0.0,ci=0.0;
void check(char f,char d)
{		//char f,d;
		if(f=='c' && d=='s'){cs++;}
		if(f=='a' && d=='i'){ai++;}
		if(f=='c' && d=='i'){ci++;}
		if(f=='m' && d=='e'){me++;}
		if(f=='e' && d=='e'){ee++;}
	return ;
}


int graph4()
{
SimpleWindow dk("Graph analysing the branches of various students admitted to IIT",25.0,15.0,Position(1.0,1.0));	

//INITIALISING THE GRAPHS REQD FOR DATA HANDLING	
struct bgraph b[100];
struct dgraph d[100];
struct kgraph k[100];
struct rgraph r[100];
struct mgraph m[100];
int i,y1,y2,y3,y4,y5;
c(b,k,d,r,m,y1,y2,y3,y4,y5);
				
				     
	
//USER GIVES INPUT REGARDING THE RANK UPTO WHICH HE WANTS TO ANALYSE THE RANKS

	int uplim2;
	cout<<"ENTER THE UPPER LIMIT OF THE RANK YOU WANT TO ANALYSE BUT LESS THAN EQUAL TO TOTAL NO. OF STUDENTS  ("<<readstudentslist(s,ar)<<"):"<<endl;
	cin>>uplim2;	
	if(uplim2>readstudentslist(s,ar))
	{cout<<"Sorry ,these many ranks have not been allotted"<<endl;
	 return 1;
	}
	i=0;


	FILE *fp1,*fp2,*fp3,*fp4,*fp5;
//CHECKING THE RANKS OF STUDENTS IN IIT BOMBAY TO BE IN THE WITHIN THE DESIRED RANGE USING UPPER DEFINED FUNCTION 'check'...
	fp1=fopen("B.txt","r");
	if (fp1==NULL)
		{}	
	else{	
		 
		while(atoi(b[i].rank)<uplim2+1 && i<y1)		
			{check(b[i].branch[1],b[i].branch[2]);
			 i++;	
			}
	    }
	i=0;
//CHECKING THE RANKS OF STUDENTS IN IIT DELHI TO BE IN THE WITHIN THE DESIRED RANGE USING UPPER DEFINED FUNCTION 'check'...
	fp2=fopen("D.txt","r");
	if (fp2==NULL)
		{}	
	else{	
		while(atoi(d[i].rank)<uplim2+1 && i<y2)		
			{check(d[i].branch[1],d[i].branch[2]);
			i++;	
			}
	    }
	i=0;
//CHECKING THE RANKS OF STUDENTS IN IIT KANPUR TO BE IN THE WITHIN THE DESIRED RANGE USING UPPER DEFINED FUNCTION 'check'...
	fp3=fopen("K.txt","r");
	if (fp3==NULL)
		{}	
	else{
		while(atoi(k[i].rank)<uplim2+1 && i<y3)		
			{check(k[i].branch[1],k[i].branch[2]);
			i++;	
			}
	    }	
	i=0;
//CHECKING THE RANKS OF STUDENTS IN IIT ROORKEE TO BE IN THE WITHIN THE DESIRED RANGE USING UPPER DEFINED FUNCTION 'check'...
	fp4=fopen("R.txt","r");
	if (fp4==NULL)
		{}	
	else{
		while(atoi(r[i].rank)<uplim2+1 && i<y4)		
			{check(r[i].branch[1],r[i].branch[2]);
			i++;	
			}
	    }
	i=0;
//CHECKING THE RANKS OF STUDENTS IN IIT MADRAS TO BE IN THE WITHIN THE DESIRED RANGE USING UPPER DEFINED FUNCTION 'check'...
	fp5=fopen("M.txt","r");
	if (fp5==NULL)
		{}	
	else{
		while(atoi(m[i].rank)<uplim2+1 && i<y5)		
			{check(m[i].branch[1],m[i].branch[2]);
				i++;	
	    		}
	    }
	

//CREATING THE REFERENCE LINES IN THE GRAPHS

	float x,q=14.0,r1=2.0;
	dk.Open();
	assert(dk.GetStatus()==WindowOpen);
	for(x=1.0;x<=25.0;x=x+1.0)
		{dk.RenderLine(Position(x,0.0),Position(x,q),Black,0.0);}
	for(x=1.0;x<=q;x=x+1.0)
		 {dk.RenderLine(Position(1.0,x),Position(25.0,x),Black,0.0);
		}
	
//FLEXIBLE SCALING OF THE GRAPH
//HERE 'p' HAS BEEN USED AS A VARIABLE WHICH ADJUSTS THE SCALE OF THE GRAPHS ACCORDING TO THE DATA RECEIVED

	float p;
	for(p=0;;)
		{
		 p++;
		 if((cs/p<q) && (ai/p<q) && (me/p<q) && (ee/p<q) && (ci/p<q))
		 {break;}
		 }
		  
		
//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE VERTICAL AXIS
	char header[15],str[15];
	int n;
	for(n=0;n<14;n++)
	{
	int j1=n*p;
	sprintf(str,"%d",j1);
	sscanf(str,"%s",header);
			Position UpperLeft = Position(0.0,q-n-0.5);
			Position LowerRight = Position(1.0,q-n+0.5);
			dk.RenderText(UpperLeft, LowerRight,header, Red);
		}
		
	dk.RenderRectangle(Position(r1,q-cs/p),Position(r1+1,q),Blue,false);
	dk.RenderRectangle(Position(r1+2,q-ai/p),Position(r1+3,q),Blue,false);		
	dk.RenderRectangle(Position(r1+4,q-ci/p),Position(r1+5,q),Blue,false);
	dk.RenderRectangle(Position(r1+6,q-me/p),Position(r1+7,q),Blue,false);
	dk.RenderRectangle(Position(r1+8,q-ee/p),Position(r1+9,q),Blue,false);
		

//LOOP FOR WRITING THE VALUES OF THE SCALE ON THE HORIZONTAL AXIS
	{	Position UpperLeft = Position(r1,q);
		Position LowerRight = Position(r1+1,q+1);
		dk.RenderText(UpperLeft, LowerRight,"cse", Blue);
	}
	{	Position UpperLeft = Position(r1+2,q);
		Position LowerRight = Position(r1+3,q+1);
		dk.RenderText(UpperLeft, LowerRight,"aero", Blue);
	}
	{	Position UpperLeft = Position(r1+4,q);
		Position LowerRight = Position(r1+5,q+1);
		dk.RenderText(UpperLeft, LowerRight,"civil", Blue);		
	}
	{	Position UpperLeft = Position(r1+6,q);
		Position LowerRight = Position(r1+7,q+1);
		dk.RenderText(UpperLeft, LowerRight,"mech", Blue);
	}
	{	Position UpperLeft = Position(r1+8,q);
		Position LowerRight = Position(r1+9,q+1);
		dk.RenderText(UpperLeft, LowerRight,"elec.", Blue);
		dk.RenderText(UpperLeft, LowerRight,"elec.", Blue);
	}	
	
	sleep(10);
return 0;
}
